@ECHO OFF
CLS
IF NOT EXIST MAPEDIT.EXE goto error
IF NOT EXIST MAPEDIT.INI goto error
ECHO.>PMAPED\PATCH.LOG
:pscreen
CLS
PMAPED\SCRN S>nul
ECHO.
ECHO.
ECHO    [0;36mSELECT WHAT YOU WANT TO BE PATCHED                    [1;31mPRESS [1;32m[X][1;31m TO EXIT[0m
ECHO    -----------------------------------------------------------------------
ECHO    [1;32m[1] [1;37mAPPLY BASIC MAPEDIT PATCH ([1;33mPMAPEDIT [1;34mBETA9[1;37m). [1;33m*[0m
ECHO        - Compatible with vanilla map editor. Press [0;32m[I][0m key to see 
ECHO          full changelog.
ECHO.
ECHO    [1;32m[2] [1;37mUSE MAPEDIT.INI TO STORE SETTINGS.[0m [1;33m*[0m
ECHO        - Allows to store video and sound settings in MAPEDIT.INI. Can be
ECHO          useful for DOS user that tired to switch video resolution.
ECHO.
ECHO    [1;32m[3] [1;37mADD BLOODGDX TYPE NAMES IN 2D MODE LIST.[0m
ECHO        - It will add 12 new types that opens wide range of new features
ECHO          for mappers. Currently compatible with BloodGDX only.
ECHO.
ECHO    [1;32m[3] [1;37mDISABLE SPRITE PALETTE AUTO-ADJUSTING.[0m
ECHO        - Allows to paint monsters and other things that cannot be painted.
ECHO.
ECHO    [1;32m[4] [1;37mDISABLE SPRITE SIZE AUTO-ADJUSTING.[0m
ECHO        - Allows to resize monsters and other things that cannot be resized.
ECHO.
ECHO    [1;32m[5] [1;37mUNLOCK HIDDEN COMMANDS BETWEEN 11 AND 64. [1;33m*[0m
ECHO        - Not tested carefully, so you have to experiment :)
ECHO.
ECHO    [1;35m[0] [1;37mDISABLE AUTO-ADJUST FUNCTION COMPLETELLY.[0m
ECHO        - Recommended only if sure you can control everything manually.
CHOICE /C:1234560ix /N " "
CLS
IF ERRORLEVEL 9 goto exit
IF ERRORLEVEL 8 goto beta3info
IF ERRORLEVEL 7 goto full
IF ERRORLEVEL 6 goto cmd
IF ERRORLEVEL 5 goto size
IF ERRORLEVEL 4 goto pal
IF ERRORLEVEL 3 goto type
IF ERRORLEVEL 2 goto ubind
IF ERRORLEVEL 1 goto basic
goto exit

:beta3info
CLS
PMAPED\SCRN D>nul
PMAPED\QSCROLL PMAPED\CHLOG.TXT
goto pscreen

:basic
PMAPED\MP PMAPED\PBASIC1.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\PBASIC3.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\PBASIC4.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\PBASIC5.CRK /C /P>>PMAPED\PATCH.LOG

PMAPED\MP PMAPED\MAPDSTYP.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\HEXPLDR.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\STRINGS.CRK /C /P>nul
goto board_size

:board_size
ECHO.
ECHO  [1;37mDO YOU WANT INCREASE MAPEDIT'S BOARD SIZE? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  This will increase board size from 131 072 to 196 608.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 goto diff_sky
IF ERRORLEVEL 1 goto board_size_continue

:board_size_continue
PMAPED\MP PMAPED\PBASIC2.CRK /C /P>>PMAPED\PATCH.LOG
goto diff_sky

:diff_sky
ECHO.
ECHO  [1;37mDO YOU WANT BE ABLE TO SET DIFFERENT SKY FOR EACH SECTOR? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  If you need set same picture for all parallaxed sectors, you still 
ECHO  can use Ctrl+Enter key combination.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 goto basic_continue
IF ERRORLEVEL 1 goto diff_sky_continue

:diff_sky_continue
PMAPED\MP PMAPED\DIFFSKY.CRK /C /P>>PMAPED\PATCH.LOG
goto basic_continue

:basic_continue
CLS
ECHO.
ECHO  [1;37mBASIC PATCH HAS BEEN APPLIED.
ECHO  DO YOU WANT TO ACTIVE UNUSED ITEMS TO BE ADDED IN ITEMS MENU? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  This will add items such as Gas Mask, Red Potion and Feather Fall to 
ECHO  items menu in 3D mode (Alt+S) by replacement inactive shrooms. It will 
ECHO  also replace Wooden Chest to Medicine Pouch.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 goto pscreen
IF ERRORLEVEL 1 goto items
goto pscreen

:items
IF EXIST PMAPED\GMITEM.CRK PMAPED\MP PMAPED\GMITEM.CRK /C /P>>PMAPED\PATCH.LOG
IF EXIST PMAPED\FFITEM.CRK PMAPED\MP PMAPED\FFITEM.CRK /C /P>>PMAPED\PATCH.LOG
IF EXIST PMAPED\MPITEM.CRK PMAPED\MP PMAPED\MPITEM.CRK /C /P>>PMAPED\PATCH.LOG
IF EXIST PMAPED\RPITEM.CRK PMAPED\MP PMAPED\RPITEM.CRK /C /P>>PMAPED\PATCH.LOG
CLS
ECHO.
ECHO  ITEMS HAS BEEN ADDED IN SPRITES MENU. 
ECHO  TO USE THEM, PRESS ALT+S IN 3D MODE AND SELECT "ITEMS".
ECHO  PRESS ANY KEY TO RETURN...
pause>nul
goto pscreen

:type
PMAPED\SCRN D>nul
ECHO  [1;31m
ECHO  IMPORTANT! 
ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT
ECHO  AND NEW TYPES WILL NOT WORK IN DOS VERSION OF BLOOD!
ECHO.
ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, UNLOCKED TYPES
ECHO  WILL RESET BACK TO ZERO. CONTINUE? [1;32m[Y/N][0m
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 goto pscreen
IF ERRORLEVEL 1 goto types_confirmed


::type
::PMAPED\SCRN D
::ECHO  [1;31m
::ECHO  IMPORTANT! 
::ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT!
::ECHO.
::ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, UNLOCKED TYPES
::ECHO  WILL RESET BACK TO ZERO. CONTINUE? [1;32m[Y/N][0m
::CHOICE /C:yn /N " "
::CLS
::IF ERRORLEVEL 2 goto pscreen
::IF ERRORLEVEL 1 goto types_confirmed

:types_confirmed
::PMAPED\MP PMAPED\MAPDSTYP.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\GDXTYP.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\INCMAX.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\NEGATIV.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\STRINGS.CRK /C /P>nul
CLS
ECHO  [1;37m
ECHO  NEW TYPES HAS BEEN ADDED IN LIST. THEY WILL ABLE VIA ALT+F6 IN 2D MODE.
ECHO  [0m
ECHO  PRESS ANY KEY TO RETURN...
pause>nul
goto pscreen

:::types_confirmed
::PMAPED\MP PMAPED\MAPDSTYP.CRK /C /P>>PMAPED\PATCH.LOG
::PMAPED\MP PMAPED\STRINGS.CRK /C /P>nul
::CLS
::ECHO  [1;37m
::ECHO  HIDDEN TYPES HAS BEEN UNLOCKED. TO USE THIS FEATURE,
::ECHO  PRESS ALT+T ON SPRITE IN 2D MODE AND TYPE NUMBER YOU
::ECHO  NEED.
::ECHO.
::ECHO  DO YOU WANT ALSO ADD NEW ITEMS IN TYPES LIST? [1;32m[Y/N][0m
::ECHO  --------------------------------------------------------------------
::ECHO.
::ECHO  This will add 17 new types in mapedit's 2D Mode list. Also will replace 
::ECHO  some hazard sprites to Armed Bundle of TNT, Armed aerosol and Armed TNT
::ECHO  stick in Hazard sprites menu.
::CHOICE /C:yn /N " "
::CLS
::IF ERRORLEVEL 2 goto pscreen
::IF ERRORLEVEL 1 goto type_add_new
::goto pscreen

:::type_add_new
::CLS
::PMAPED\MP PMAPED\TYPEADD.CRK /C /P>>PMAPED\PATCH.LOG
::PMAPED\MP PMAPED\HZTHING.CRK /C /P>>PMAPED\PATCH.LOG
::PMAPED\MP PMAPED\AATHING.CRK /C /P>>PMAPED\PATCH.LOG
::PMAPED\MP PMAPED\ABTHING.CRK /C /P>>PMAPED\PATCH.LOG
::PMAPED\MP PMAPED\ASTHING.CRK /C /P>>PMAPED\PATCH.LOG
::CLS
::ECHO  [1;37m
::ECHO  NEW TYPES HAS BEEN ADDED IN LIST. THEY WILL ABLE VIA ALT+F6 IN 2D MODE.
::ECHO  [0m
::ECHO  PRESS ANY KEY TO RETURN...
::pause>nul
::goto pscreen

:pal
PMAPED\SCRN D>nul
ECHO  [1;31m
ECHO  IMPORTANT! 
ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT!
ECHO.
ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, PALETTES
ECHO  WILL RESET TO THEIR PREDEFINED VALUES. CONTINUE? [1;32m[Y/N][0m
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 goto pscreen
IF ERRORLEVEL 1 goto pal_confirmed
:pal_confirmed
PMAPED\MP PMAPED\MAPDSPAL.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\STRINGS.CRK /C /P>nul
CLS
ECHO  [1;37m
ECHO  PALETTE CONTROL DISABLED, PRESS ANY KEY TO RETURN...
pause>nul
goto pscreen

:size
PMAPED\SCRN D>nul
ECHO  [1;31m
ECHO  IMPORTANT! 
ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT!
ECHO.
ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, SIZE
ECHO  WILL RESET TO IT'S PREDEFINED VALUES. CONTINUE? [1;32m[Y/N][0m
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 goto pscreen
IF ERRORLEVEL 1 goto size_confirmed
:size_confirmed
PMAPED\MP PMAPED\MAPDSIZE.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\STRINGS.CRK /C /P
CLS
ECHO  [1;37m
ECHO  SPRITE SIZE CONTROL DISABLED, PRESS ANY KEY TO RETURN...
pause>nul
goto pscreen


:cmd
PMAPED\MP PMAPED\MAPDCMD.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\STRINGS.CRK /C /P>nul
CLS
ECHO  [1;37m
ECHO  COMMANDS UNLOCKED, PRESS ANY KEY TO RETURN...
pause>nul
goto pscreen


:full
PMAPED\MP PMAPED\MAPDAAD.CRK /C /P>>PMAPED\PATCH.LOG
PMAPED\MP PMAPED\STRINGS.CRK /C /P
CLS
ECHO  [1;37m
ECHO  AUTO-ADJUST FUNCTION DISABLED.
ECHO  YOU ARE ON YOUR OWN NOW! :) PRESS ANY KEY TO RETURN...
pause>nul
goto pscreen

:ubind
CLS
IF NOT EXIST PMAPED\MAPEDIT.INI COPY MAPEDIT.INI PMAPED\MAPEDIT.INI>>PMAPED\PATCH.LOG
IF EXIST MAPEDIT.INI DEL MAPEDIT.INI>>PMAPED\PATCH.LOG
COPY PMAPED\MAPEDIT.INI MAPEDIT.INI>>PMAPED\PATCH.LOG
TYPE BLOOD.CFG>>MAPEDIT.INI
PMAPED\MP PMAPED\MAPDCFG.CRK /c /p>>PMAPED\PATCH.LOG
CLS
ECHO  [1;37m
ECHO  SETTINGS FROM BLOOD.CFG HAS BEEN COPIED TO MAPEDIT.INI.
ECHO  YOU HAVE TO EDIT IT IN NOTEPAD. IT'S RECOMMENDED TO SET
ECHO  RESOLUTION TO 320x200 PIXELS.
ECHO.
ECHO  PRESS ANY KEY TO RETURN...
pause>nul
goto pscreen

:error
CLS
ECHO  [1;31m
ECHO  NO MAPEDIT.EXE OR MAPEDIT.INI FOUND IN CURRENT DIRECTORY.
ECHO  PRESS ANY KEY TO EXIT...
ECHO  NO MAPEDIT FOUND>>PMAPED\PATCH.LOG
pause>nul


:exit
CLS
PMAPED\SCRN D>nul
ECHO  [1;37m
ECHO  EXITING PROGRAM...[0m


